package io.aalam.testapp;

import io.aalam.common.Role;
import io.aalam.common.HttpRequest;
import io.aalam.common.HttpResponse;
import io.aalam.common.serializers.JsonSerializer;

class IndexHookSerializer extends JsonSerializer {
    String url;

    public IndexHookSerializer(String url) {
        this.url = url;
    }
    public byte[] toJson(HttpRequest request, HttpResponse response) {
        return ("{\"entry\": \"" + this.url + "\"," +
                "\"content\": null}").getBytes();
    }
}

public class HookHandler {

    public static Object indexHookHandler(HttpRequest request) {
        /* We present different entry points
         *   For admin user or users with Items/create permisssion
         * create form will be shown
         *   For authenticated users who is not authorized enought to create
         * items, can still access the items and items search page will
         * shown
         *   For the anonymous users, a general information will be shown
         */
        try {
        if (Role.isUserAdmin(request.auth().email()) ||
            Role.isClientAuthorized(request, "Items", "create")) {
            return new IndexHookSerializer("/aalam/testapp/s/create_form.html");
        } else if (!request.auth().isAnonymous()) {
            return new IndexHookSerializer("/aalam/testapp/s/items_access.html");
        } else {
            return new IndexHookSerializer("/aalam/testapp/");
        }
        } catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
